import 'dart:async';

abstract class BolterRoute<R> {
  final _completer = Completer<R?>();

  R? result;

  @override
  bool operator ==(Object other) {
    if (other is BolterRoute) {
      return runtimeType == other.runtimeType;
    }
    return false;
  }
  // true if annotated with HiveType, false to ignore persisting
  bool get persisting => true;

  @override
  int get hashCode => runtimeType.hashCode;

  void complete() => _completer.complete(result);

  Future<R?> get whenComplete => _completer.future;
}
